#include <OneWire.h>
#include "devicefamily.h"
// DS18S20 Temperature chip i/o
OneWire ds(10);  // on pin 10

void setup(void) {
  // initialize inputs/outputs
  // start serial port
  Serial.begin(9600);

  ds.reset(); //reset the bus
  ds.reset_search(); //reset the bus search algorithm
  
}

void loop(void) {
  byte i;
  byte present = 0;
  byte data[12];
  char buffer[55]; //for printing family id
  
  byte devId[8]; //device id 
//  bool found = ds.search(devId); //search for device

  //if (found)
  while (ds.search(devId)) //detect all devices 
  {
    //print device id
    Serial.print("id=");
    for( i = 0; i < 8; i++) 
    {
      Serial.print(devId[i], HEX);
      if (i<7) Serial.print(":");
    }
    Serial.print(" ");
    
    //detect device family
    for (i=0; i<numFamilies; i++)
    {
      if (devId[0] == familyId[i]) //match found?
      {
        strcpy_P(buffer, (char*)pgm_read_word(&(families[i]))); // copy family name from program space buffer to ram for printing
        Serial.print(buffer); //print family name
      }
    }    
    Serial.println();
  }
  Serial.println("end of search");
}

